#include<iostream>
#include<ezwin.h>
#include<bitmap.h>
#include<cstdlib>
#include<cstdio>

//Macros
#define WINDOW_WIDTH 20.0
#define WINDOW_HEIGHT 15.0
#define groundheight 5.0
//for making the man run, jump and slide

//defining the global variable
int flag=0;


//declaration of simple windows
SimpleWindow BlockEvader("BlockEvader",WINDOW_WIDTH,WINDOW_HEIGHT,Position(2.0,2.0));

//declaration of bitmaps
BitMap man1(BlockEvader);
BitMap man2(BlockEvader);

void wait (float seconds )
{
  clock_t endwait;
  endwait = clock () + (seconds * CLOCKS_PER_SEC)/1000;
  while (clock() < endwait){}
}

#define Steps 100

void jump(BitMap &Image,const Position &Start,const Position &End){
    float StartX=Start.GetXDistance();
    float StartY=Start.GetYDistance();
    float EndX=End.GetXDistance();
    float EndY=End.GetYDistance();
    Position Present=Start;
    for(int k=0;k <= Steps+1;k++){Image.Erase();
     Position PhotoPosition = Present + Position(-0.5*Image.GetWidth(),-0.5*Image.GetHeight());
        Image.SetPosition(PhotoPosition);
	    Image.Draw();
	    Present = Present + Position((EndX-StartX)/Steps,(EndY-StartY)/Steps);
	    wait(20.0);
    }
    
}



int check_pos_click(const Position &MousePosition)
{
	if(MousePosition.GetYDistance()< (WINDOW_HEIGHT-groundheight))
	{  jump(man1,Position(5.0,10.0),Position(5.0,14.0));
           jump(man1,Position(5.0,14.0),Position(5.0,10.0));
	}
return 1;
}
void run()
{
	flag++;
	//for making the man run
	if(flag%2==1)
		{Position man1_pos=(5.0,10.0);
man1.SetPosition(man1_pos);
                 man1.Draw();
		}
	
	else
		{Position man2_pos=(5.0,10.0);
man2.SetPosition(man2_pos);
man2.Draw();
		}
	//for making the man jump or slide
	BlockEvader.SetMouseClickCallback(check_pos_click);
	
}




int ApiMain() {
BlockEvader.Open();
//loading the images
man1.Load("man1.xpm");
man2.Load("man2.xpm");

run();
return 0;
}

int ApiEnd() {
BlockEvader.Close();
return 0;
}
